subroutine buoyant(tmp,rat,buoy)
  use constants; use division
!**********************************************************************
!     calculate buoyancy at mesh points
!
!     buoy := rat*tmp
!
!     input
!        tmp: temperature
!        rat: thermal Rayleigh number
!     output
!        buoy: buoyancy
!**********************************************************************
  implicit none

  integer :: i,j,k
  real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: buoy,tmp
  real(dp),intent(in) :: rat

  buoy = rat*tmp

  return
end subroutine buoyant
