subroutine htrns3(tmpl,ul,vl,wl,schl,tsurf,tbot,qbot,vboti,dt,crmax,isolver)
  use constants; use mesh; use mympitools; use division
  !*********************************************************************
  !*********************************************************************
  implicit none

  real(dp) :: tsurf,tbot,qbot,vboti,dt,crmax
  real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: tmpl,schl,ul,vl,wl
  integer :: isolver

  if (crmax <= 0.25e0_dp) then
     call htrns3e1(tmpl,ul,vl,wl,schl,tsurf,tbot,qbot,vboti,dt)
  else if (crmax <= 0.5e0_dp) then
     call htrns3e2(tmpl,ul,vl,wl,schl,tsurf,tbot,qbot,vboti,dt)
  else
     call htrns3i(tmpl,ul,vl,wl,schl,tsurf,tbot,qbot,vboti,dt,isolver)
  endif

  return
end subroutine htrns3
